define([
    'jquery',
    'angular',
    'uiRouter',
    'ocLazyLoad',       
    './controllers',    
    './services',
    './directives',
    './filters',     
    'angularSanitize',
    'jmigrate',
    'bstrap',
    'btpls',
    'uiselect',
    'slimscroll',
    'main', 
    'layout', 
    'sidebar',
    'hdropdown',   
    'blockui',    
    'uniform',
    'uiutils',
    'bselect',
    'uiutils',    
    'select2',
    'mselect',
    'datatables.net',
    'bdtables',    
    'datatables.net-buttons',    
    'dtbflash',
    'dtbzip',
    'dtbpdf',
    'dtbfonts',
    'dtbhtml',
    'dtbprint',
    'adtables',
    'adtbuttons'
       
], function (jQuery, ng, uiRouter, ocLazyLoad, controllers, services, directives, filters) {
    'use strict';    

    //Initailize the app and pull together all the dependancies here
    var survey = ng.module('survey', [
        'ui.router',
        'survey.services',
        'survey.controllers',
        'survey.directives', 
        'survey.filters',
        'ui.bootstrap',
        'ngSanitize',
        'oc.lazyLoad',        
        'ui.select',        
        'datatables',
        'datatables.buttons'
    ]);

    
    survey.factory('$exceptionHandler', function(){
        return function(exception, cause){
            console.log(exception, cause);
        };
    });
        
    
    survey.run(['$rootScope', '$state', '$stateParams', 'properties', 'settings', '$interval', '$timeout', function($rootScope, $state, $stateParams, properties, settings, $interval, $timeout) {      
        
        $rootScope.$state = $state;
        $rootScope.$stateParams = $stateParams;

        $rootScope.$settings = settings; // state to be accessed from view
        
        $rootScope.hidesidebar = false;

        var showSideBar = function(){

            if($rootScope.currenturl == 'login' || $rootScope.currenturl == 'dashboard' ){
                $rootScope.hidesidebar = true;
            }else{
                $rootScope.hidesidebar = false;
            }

        }

        showSideBar();

        
        $rootScope.goDashboard = function(){
            $state.go('dashboard');
        }; 

        $rootScope.showCompanies = function(){
            $state.go('companies');
        }; 

        $rootScope.showSurveys = function(){
            $state.go('surveys');
        };       
        

        $rootScope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams){
            
            properties.setCurrentURL(toState.name);            

        });


        $rootScope.$on("$stateChangeSuccess", function(event, toState, toParams, fromState, fromParams){
        
            $rootScope.currenturl = properties.getCurrentURL();

            //Highlight the active menu link
            $timeout(function(){

                var navs = $('.page-sidebar-menu li.nav-item');

                navs.removeClass("active");

                angular.forEach(navs, function(value, key) {
                              
                  var target = $(value).data('target');
                  
                  if(target == $rootScope.currenturl){
                    $(value).addClass('active');
                  }
                  
                });

            });

            
        });


    }]);

    return survey;
});