define(['./module', 'jquery'], function (controllers, jQuery) {
    'use strict';
    
    controllers.controller("DashboardController", ["$scope", "$state", "settings", "properties", "$q", "$rootScope", function($scope, $state, settings, properties, $q, $rootScope) {
	   
	    // set sidebar closed and body solid layout mode
	    $rootScope.settings.layout.pageContentWhite = true;
	    $rootScope.settings.layout.pageBodySolid = false;
	    $rootScope.settings.layout.pageSidebarClosed = true;


	    $scope.surveys = properties.getSurveys();
	    $scope.companies = properties.getCompanies();


	    $q.all([

		   settings.getSurveys(),
		   settings.getCompanies(),

		]).then(function(data) {

				var survey_response = data[0].data;
			    var companies_response = data[1].data;

			    //Get surveys
			    if(survey_response.success){
		          	$scope.surveys = survey_response.surveys;
		          	properties.setSurveys(survey_response.surveys);	          	
		        }else{
		          	console.log('Server error: '+survey_response.message);
		        }


		        //Get companies
		        if(companies_response.success){
		          	$scope.companies = companies_response.companies;
		          	properties.setCompanies(companies_response.companies);	          	
		        }else{
		          	console.log('Server error: '+companies_response.message);
		        }

		 },function(error) {

	            console.log(error);

	    });

	    	     
	  }//End of the function()

	]);
});
