define(['./module', 'jquery', 'main', 'layout', 'sidebar', 'demo'], function (controllers, jQuery) {
    'use strict';

    /* Setup App Main Controller */
    controllers.controller('AppController', ['$scope', '$rootScope', function($scope, $rootScope) {
        $scope.$on('$viewContentLoaded', function() {
            App.initComponents(); // init core components
            //Layout.init(); //  Init entire layout(header, footer, sidebar, etc) on page load if the partials included in server side instead of loading with ng-include directive 
        });
    }]);


    /* Setup Layout Part - Header */
    controllers.controller('HeaderController', ['$scope', 'properties', function($scope, properties) {
        $scope.$on('$includeContentLoaded', function() {
            Layout.initHeader(); // init header
        });

        //$scope.user = properties.getUser();

    }]);


    /* Setup Layout Part - Sidebar */
    controllers.controller('SidebarController', ['$scope', '$rootScope', '$stateParams', '$state', '$interval', function($scope, $rootScope, $stateParams, $state, $interval) {
        $scope.$on('$includeContentLoaded', function() {
            Layout.initSidebar(); // init sidebar
        });

        //$rootScope.project = $stateParams.project || 'none';

    }]);


    /* Setup Layout Part - Page Header */
    controllers.controller('PageHeadController', ['$scope', '$rootScope', '$stateParams', function($scope, $rootScope, $stateParams){
        $scope.$on('$includeContentLoaded', function() {        
            Demo.init(); // init theme panel
        });

        //$rootScope.project = $stateParams.project || 'none';

    }]);


    /* Setup Layout Part - Quick Sidebar */
    controllers.controller('QuickSidebarController', ['$scope', function($scope) {
        $scope.$on('$includeContentLoaded', function() {
           setTimeout(function(){
                QuickSidebar.init(); // init quick sidebar        
            }, 2000)
        });
    }]);


    /* Setup Layout Part - Theme Panel */
    controllers.controller('ThemePanelController', ['$scope', function($scope) {
        $scope.$on('$includeContentLoaded', function() {
            Demo.init(); // init theme panel
        });
    }]);



    /* Setup Layout Part - Footer */
    controllers.controller('FooterController', ['$scope', function($scope) {
        $scope.$on('$includeContentLoaded', function() {
            Layout.initFooter(); // init footer
        });

        var d = new Date();
        $scope.year = d.getFullYear();

    }]);   


});
