define(['./module', 'jquery'], function (controllers, jQuery) {
    'use strict';
    
    controllers.controller("LoginController", ["$scope", "$timeout", "settings", "properties", "$state", function($scope, $timeout, settings, properties, $state) {
	    	 

			$scope.mainuser = {};

		    $scope.newuser = {};

		    $scope.user = {};

		    $scope.renew = {};
		    properties.setBackground(true);

		    var d = new Date();
        	$scope.year = d.getFullYear();

		    $scope.logout = function(){      		
	            //$scope.authObj.$signOut();
	      	};

	      	$scope.cancel_login = function() {              
		        $scope.user = {};               
		        $scope.login_form.$setPristine();
		        $scope.login_form.$setUntouched();
		    };

		    $scope.cancel_register = function() {              
		        $scope.newuser = {};               
		        $scope.register_form.$setPristine();
		        $scope.register_form.$setUntouched();
		    };

		    $scope.tokenize = function(token,user){

	        	$scope.authObj.$signInWithCustomToken(token).then(function(authData){			                      	                      
			           
			           var x = user;
			           x.uid = authData.uid;		           			           
			           
                       properties.setUser(x);
                       
                       $state.go('dashboard');

                }).catch(function(error){
					 
					  var errorCode = error.code;
					  var errorMessage = error.message;
					  console.log(errorCode);
					  console.error(errorMessage);
					  $scope.error = errorMessage;
			          $('#login_form').find('.alert').css('display', 'block');
					 
				});

	        };

		    $scope.login = function() {
		      
		      	$scope.message = null;
		      	$scope.error = null;

		        var promise = settings.login($scope.mainuser);

	            promise.then(function(data) {

		              var response = data.data;

		              if(response.success){
		                    
		                    $scope.logout(); //logout any user who may be still logged in
		                    $scope.cancel_login();
		                    $scope.tokenize(response.token,response.user);

		              }else if(!response.success){
		              	  console.log(response);			                  
		                  $scope.error = response.error;
		                  $('#login_form').find('.alert').css('display', 'block');                        
		              }
		          },
		          function(error) {
		              $scope.error = error;
		              $('#login_form').find('.alert').css('display', 'block');
		        });	    


		    };


		    $scope.createUser = function() {
		      
		        $scope.message = null;
		        $scope.error = null;

		        //Check if the email address is already taken
	            var status = settings.checkAvailableEmail($scope.mainuser.email);

	            status.then(function(data) {
	            	
	            	//console.log(data);

	            	if(data == true){
	            		$scope.error = 'Sorry that email address is already taken';
	                    $('#register_form').find('.alert').css('display', 'block');
	            	}else{

	            		//Register the new user and log them in
	            		//console.log($scope.mainuser.email);
	            		//Get a hash for the password
	            		var promise = settings.getPassword($scope.mainuser.password);
                
			            promise.then(function(data) {
			                  
			                  var response = data.data;

			                  if(response.success){
			                  	
			                      $scope.mainuser.password = response.password; 
			                      var x = datastore.createUser($scope.mainuser);
			                      
			                      x.then(function(data){

			                      	if(data != false){
			                      		
				                      	$scope.mainuser.user_id = data;

				                      	//go login
			                            //$scope.mainuser.password = null;
			                            delete $scope.mainuser.password;

			                            var resp = settings.getUserToken($scope.mainuser);

			                            resp.then(function(data){			                                  
			                                  
			                                  $scope.logout(); //logout any user who may be still logged in
			                                  var x = data.data;
			                                  
			                                  if(x.success){			                                  		

			                                    $scope.tokenize(x.token,x.user);

			                                  }else if(!x.success){
			                                  	  console.error(x.error);
			                                  	  $scope.error = x.error;
	                 			  	  			  $('#register_form').find('.alert').css('display', 'block');				                                      
			                                  }

			                              },function(error) {
			                              	  console.error(error);
			                              	  $scope.error = error;
	                 			  	  		  $('#register_form').find('.alert').css('display', 'block');				                                  
			                            });

				                    }

			                      },function(error){
					                  console.error(error);
					                  $scope.error = error;
	                 			  	  $('#register_form').find('.alert').css('display', 'block');
					              });

			                  }else if(!response.success){
			                      console.error(response.error);
			                      $scope.error = response.error;
	                 			  $('#register_form').find('.alert').css('display', 'block');
			                  }
			              },function(error) {                  
			                  
			                  console.error(error);
			                  $scope.error = error;
	                  		  $('#register_form').find('.alert').css('display', 'block');

			            });

	            	}

	            },function(error) {
                      console.error(error);
                      $scope.error = error;
	                  $('#register_form').find('.alert').css('display', 'block');
                });
		              
		        

		    };//End of createUser


		    


		    //Login form
		        
		    $scope.loginOk = function () {
		        
		        $scope.login_form.submitted = false;       

		        if ($scope.login_form.$valid) {
		            $scope.mainuser.username = $scope.user.login_username;
		            $scope.mainuser.password = $scope.user.login_password;
		            $scope.cancel_login();
		            $scope.login();

		        }else{
		            
		            $scope.login_form.submitted = true;          
		        }

		    };


		    //Register form	        
		    $scope.registerOk = function () {
		        
		        $scope.register_form.submitted = false;

		        if ($scope.register_form.$valid) {

		            $scope.mainuser.email = $scope.newuser.register_email;
		            $scope.mainuser.fullname = $scope.newuser.register_fullname;
		            $scope.mainuser.username = $scope.newuser.register_username;
		            $scope.mainuser.usertype = $scope.newuser.register_user_type;
		            $scope.mainuser.password = $scope.newuser.register_password;

		            $scope.createUser();
		            $scope.cancel_register();

		        }else{
		            
		            $scope.register_form.submitted = true;          
		        }

		    };	





	    	     
	  }//End of the functio(){}

	]);
});
