define(['./module', 'jquery'], function (controllers, jQuery) {
    'use strict';
   

    //The notice modal controller

    controllers.controller('NoticeModalController', ['$scope', '$uibModalInstance', 'details', function($scope, $uibModalInstance, details) {

        $scope.details = details;
            
        $scope.noticeOk = function () {
            $uibModalInstance.close($scope.details);
        };

        $scope.noticeCancel = function () {
            $uibModalInstance.dismiss('cancel');
        };

    }]);


    //The confirm modal controller

    controllers.controller('ConfirmModalController', ['$scope', '$uibModalInstance', 'message', function($scope, $uibModalInstance, message) {

        $scope.message = message;
            
        $scope.ok = function (value) {
            $uibModalInstance.close(value);
        };

        $scope.cancel = function (value) {
            $uibModalInstance.dismiss(value);
        };

    }]); 




    //The show survey modal controller

    controllers.controller('ShowSurveyModalController', ['$scope', '$uibModalInstance', 'survey', function($scope, $uibModalInstance, survey) {

        $scope.survey = survey;        
            
        $scope.ok = function () {
            $uibModalInstance.close($scope.survey);
        };

        $scope.cancel = function () {
            $uibModalInstance.dismiss('cancel');
        };

    }]);




    //The show company modal controller

    controllers.controller('ShowCompanyModalController', ['$scope', '$uibModalInstance', 'company', function($scope, $uibModalInstance, company) {

        $scope.company = company;        
            
        $scope.ok = function () {
            $uibModalInstance.close($scope.company);
        };

        $scope.cancel = function () {
            $uibModalInstance.dismiss('cancel');
        };

    }]);



    //The new company modal controller

    controllers.controller('NewCompanyModalController', ['$scope', '$uibModalInstance', 'settings', function($scope, $uibModalInstance, settings) {
      

        $scope.newcompany = {};

        $scope.cancel_new = function() {              
            $scope.newcompany = null;               
            $scope.new_company_form.$setPristine();
            $scope.new_company_form.$setUntouched();
        };
            
        $scope.newOk = function () {
            
            $scope.new_company_form.submitted = false;

            if ($scope.new_company_form.$valid) {

                var result = {
                    newcompany : $scope.newcompany
                };

                $uibModalInstance.close(result);

            }else{
                
                $scope.new_company_form.submitted = true;          
            }

        };


        $scope.newCancel = function () {
            $scope.cancel_new();
            $uibModalInstance.dismiss('cancel');
        };


    }]);



    //The edit company modal controller

    controllers.controller('EditCompanyModalController', ['$scope', '$uibModalInstance', 'companyid', 'editcompany', 'settings', function($scope, $uibModalInstance, companyid, editcompany, settings) {
        
        $scope.editcompany_id = companyid;

        $scope.editcompany = editcompany;

        $scope.cancel_edit = function() {              
            $scope.editcompany = null;               
            $scope.edit_company_form.$setPristine();
            $scope.edit_company_form.$setUntouched();
        };
            
        $scope.editOk = function () {

            $scope.edit_company_form.submitted = false;

            if ($scope.edit_company_form.$valid) {

                var result = {
                    company: $scope.editcompany
                }

                $uibModalInstance.close(result);

            }else {
                  $scope.edit_company_form.submitted = true;          
            }
        };

        $scope.editCancel = function () {
            $scope.cancel_edit();
            $uibModalInstance.dismiss('cancel');
        };

    }]);






});
