define(['./module', 'jquery', 'main', 'layout', 'sidebar', 'demo'], function (controllers, jQuery) {
	'use strict';

    controllers.controller('UserProfileController', ['$rootScope', '$scope', '$http', '$timeout', 'properties', 'datastore', 'settings', 'modals', function($rootScope, $scope, $http, $timeout, properties, datastore, settings, modals) {
        

	    // set sidebar closed and body solid layout mode
	    $rootScope.settings.layout.pageBodySolid = true;
	    $rootScope.settings.layout.pageSidebarClosed = true;

	    $scope.user = properties.getUser();

	    if($scope.user.usertype == '1'){
	    	$scope.user.category_name = 'Administrator'
	    }else if($scope.user.usertype == '2'){
	    	$scope.user.category_name = 'Content Manager'
	    }

	    $scope.edituser = $scope.user;

	   

	    $scope.newuser = {};

	    $scope.cancel_new = function(form) {
	        $scope.register_form = form;              
	        $scope.newuser = {};               
	        $scope.register_form.$setPristine();
	        $scope.register_form.$setUntouched();
	    };

	        
	    $scope.newOk = function (form) {

	        $scope.register_form = form;
	        
	        $scope.register_form.submitted = false;

	        if ($scope.register_form.$valid) {

	               $scope.new_user = {
	                    fullname: $scope.newuser.register_fullname,                        
	                    username: $scope.newuser.register_username,
	                    password: $scope.newuser.register_password,
	                    email: $scope.newuser.register_email,    
	                    ucd: $scope.newuser.register_usid
	               }; 

	            
	               var promise = datastore.addUser($scope.new_user);
	                   
	               settings.show_wait();

	               promise.then(function(data) {

	                    var response = data.data;

	                    if(response.success){

	                      modals.showNoticeModal(response.message,'Info');
	                      $scope.message = response.message;
	                      $('#register_form').find('.alert-success').show().css('display', 'block');

	                    }else{
	                      $scope.error = response.message;
	                      $('#register_form').find('.alert-danger').show().css('display', 'block');
	                    }

	                    settings.hide_wait();

	               },function(error) { 
	                    settings.hide_wait();
	                    console.log(error);
	               });                            
	            

	        }else{
	            
	            $scope.register_form.submitted = true;          
	        }

	    };


	    $scope.newCancel = function () {
	        $scope.cancel_new();
	        $uibModalInstance.dismiss(false);
	    };




	    $scope.cancel_edit = function(form) {
	        $scope.edit_form = form;             
	        $scope.edituser = {};               
	        $scope.edit_form.$setPristine();
	        $scope.edit_form.$setUntouched();
	    };    

	        
	    $scope.editOk = function (form) {

	        $scope.edit_form = form;
	        
	        $scope.edit_form.submitted = false;        

	        if ($scope.edit_form.$valid) {                
	            
	               var promise = datastore.editUser($scope.edituser);
	                   
	               settings.show_wait();

	               promise.then(function(data) {
	                    
	                    var response = data.data;

	                    if(response.success){

	                      modals.showNoticeModal(response.message,'Info');
	                      $scope.message = response.message;
	                      $('#edit_form').find('.alert-success').show().css('display', 'block');

	                    }else{
	                      $scope.error = response.message;
	                      $('#register_form').find('.alert-danger').show().css('display', 'block');
	                    }

	                    settings.hide_wait();

	               },function(error) { 
	                    settings.hide_wait();
	                    console.log(error);
	               });                            
	            

	        }else{
	            
	            $scope.edit_form.submitted = true;          
	        }

	    };


	    $scope.editCancel = function () {
	        $scope.cancel_edit();
	        $uibModalInstance.dismiss(false);
	    };





	    //Change password
	    $scope.newpassword = {};

	    $scope.cancel_password = function(form) {
	        $scope.cp_form = form;              
	        $scope.newpassword = {};               
	        $scope.cp_form.$setPristine();
	        $scope.cp_form.$setUntouched();
	    };

	        
	    $scope.passwordOk = function (form) {
	        
	        $scope.cp_form = form;

	        $scope.cp_form.submitted = false;        

	        if ($scope.cp_form.$valid) {

	               $scope.new_password = {
	                    oldpassword: $scope.newpassword.cp_password,
	                    password: $scope.newpassword.cp_register_password,
	                    usid: $scope.user.usid
	               }; 

	               
	               var promise = datastore.updatePassword($scope.new_password);
	                   
	               settings.show_wait();

	               promise.then(function(data) {
	                    
	                    var response = data.data;

	                    if(response.success){

	                      modals.showNoticeModal(response.message,'Info');
	                      $scope.message = response.message;
	                      $('#cp_form').find('.alert-success').show().css('display', 'block');

	                    }else{
	                      $scope.error = response.message;
	                      $('#cp_form').find('.alert-danger').show().css('display', 'block');
	                    }

	                    settings.hide_wait();

	               },function(error) { 
	                    settings.hide_wait();
	                    console.log(error);
	               });                            
	            

	        }else{
	            
	            $scope.cp_form.submitted = true;          
	        }

	    };


	    $scope.cpCancel = function () {
	        $scope.cancel_password();
	        $uibModalInstance.dismiss(false);
	    };

	}]);


});