define(['./module', 'jquery', 'moment', 'datepicker'], function (directives, jQuery, moment, datepicker) {
    'use strict';

    directives.directive('datepicker', ['$rootScope', '$timeout', 'properties', function ($rootScope, $timeout, properties) {        
        
        return {
            restrict: 'EA',            
            link: function (scope, elem) {

                $timeout(function(){
                     
                    
                    var handleDatePickers = function () {

                        if (jQuery().datepicker) {                           
                            

                            // set default dates
                            var start = new Date();
                            // set end date to max one year period:
                            var end = new Date(new Date().setYear(start.getFullYear()+1));

                            $('#classified_start_date').datepicker({
                                startDate : start,
                                endDate   : end,
                                rtl: App.isRTL(),
                                orientation: "left",
                                format: 'M-dd-yyyy',
                                autoclose: true
                            // update "classified_expiry_date" defaults whenever "classified_start_date" changes
                            }).on('changeDate', function(){
                                // set the "classified_expiry_date" start to not be later than "classified_start_date" ends:
                                $('#classified_expiry_date').datepicker('setStartDate', new Date($(this).val()));
                            }); 

                            $('#classified_expiry_date').datepicker({
                                startDate : start,
                                endDate   : end,
                                rtl: App.isRTL(),
                                orientation: "left",
                                format: 'M-dd-yyyy',
                                autoclose: true
                            // update "classified_start_date" defaults whenever "classified_expiry_date" changes
                            }).on('changeDate', function(){
                                // set the "classified_start_date" end to not be later than "classified_expiry_date" starts:
                                $('#classified_start_date').datepicker('setEndDate', new Date($(this).val()));
                            });

                            //$('body').removeClass("modal-open"); // fix bug when inline picker is used in modal
                        }

                        /* Workaround to restrict daterange past date select: http://stackoverflow.com/questions/11933173/how-to-restrict-the-selectable-date-ranges-in-bootstrap-datepicker */
                    
                        // Workaround to fix datepicker position on window scroll
                        $( document ).scroll(function(){
                            $('.modal-body .date-picker').datepicker('place'); //#modal is the id of the modal
                        });
                    }  

                    handleDatePickers();

                    

                });
            }

          };

    }]);	

});
