define(['./module', 'jquery', 'jmigrate'], function (directives, jQuery) {
    'use strict';

    directives.directive('ngSpinnerBar', ["$rootScope", function ($rootScope) {
        
        var linker = function (scope, element, attrs) {

			    // by defult hide the spinner bar
                element.addClass('hide'); // hide spinner bar by default

                // display the spinner bar whenever the route changes(the content part started loading)
                $rootScope.$on('$stateChangeStart', function() {
                    element.removeClass('hide'); // show spinner bar
                });

                // hide the spinner bar on rounte change success(after the content loaded)
                $rootScope.$on('$stateChangeSuccess', function() {
                    element.addClass('hide'); // hide spinner bar
                    $('body').removeClass('page-on-load'); // remove page loading indicator                     
                });

                // handle errors
                $rootScope.$on('$stateNotFound', function() {
                    element.addClass('hide'); // hide spinner bar
                });

                // handle errors
                $rootScope.$on('$stateChangeError', function() {
                    element.addClass('hide'); // hide spinner bar
                });                

        };//End of linker

        return {
        	restrict: 'AE',            
            link: linker
        };
    }]);	

});
