define(['./module'], function (services) {

  services.factory('datastore', ["$firebaseAuth", "$firebaseArray", "$firebaseObject", "$firebaseUtils", "$rootScope", "$stateParams", "$q", function($firebaseAuth, $firebaseArray, $firebaseObject, $firebaseUtils, $rootScope, $stateParams, $q) {
          
          var config = {
            apiKey: "AIzaSyBUuBEaW8Rncm9tiEOttgAP0QsAsUuvx5E",
            authDomain: "hub-wayfinder.firebaseapp.com",
            databaseURL: "https://hub-wayfinder.firebaseio.com",
            storageBucket: "hub-wayfinder.appspot.com"
          };

          firebase.initializeApp(config);

          var dataRef = firebase.database().ref();          

          var connectedRef = firebase.database().ref(".info/connected"); 

          var storageRef = firebase.storage();         
          
          var shops_list = $firebaseArray(dataRef.child('shops'));
          var ads_list = $firebaseArray(dataRef.child('ads'));
          var classifieds_list = $firebaseArray(dataRef.child('classifieds'));
          var users_list = $firebaseArray(dataRef.child('users'));

          var shops_images_list = $firebaseArray(dataRef.child('shopimages'));
          var classifieds_images_list = $firebaseArray(dataRef.child('classifiedsimages'));

          var big_slider_images_list = $firebaseArray(dataRef.child('bigsliderimages'));
          var small_slider_images_list = $firebaseArray(dataRef.child('smallsliderimages'));
          
          var status = false;

          var progress_value = 0;
                  
          var DataStore = {

              auth: function(){
                return $firebaseAuth();
              },

              login: function(){

                var deferred = $q.defer();

                var Auth = this.auth();               

                var fUser = Auth.$getAuth();

                //If there is a user logged in return
                if(fUser){

                  deferred.resolve(fUser);

                }else{ //Else login

                  Auth.$signInWithEmailAndPassword("izoneafrica@gmail.com", "izoneafrica").then(function(firebaseUser) {
                    deferred.resolve(firebaseUser);                    
                  }).catch(function(error) {
                    console.error("Authentication failed:", error);
                    deferred.resolve(false);
                  });

                }

                return deferred.promise;                

              },

              isConnected: function(){                          
                return status;
              }, 

              setConnected: function(value){                          
                status = value;
              },


              getProgress: function(){                          
                return progress_value;
              }, 

              setProgress: function(value){                          
                progress_value = value;
              },
              
              
              //SHOPS

              allShops: function () {
                return shops_list;
              },             


              createShop: function (shop) {

                var onComplete = function(error) {
                  if (error) {
                    console.log('Adding shop failed');                    
                    console.error(error);
                  } else {
                    console.log('Adding shop succeeded');
                  }
                }; 

                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var shop_copy = $firebaseUtils.toJSON(shop);
                    var ref = dataRef.child('shops').push(shop_copy, onComplete);
                    //Auth.$signOut();  //Logout after saving data                                         
                    deferred.resolve(ref.key);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;                

              },

              getShop: function (shopId) {

                  return $firebaseObject(dataRef.child('shops').child(shopId));                
              },

              updateShop: function (shopId, shop) {

                var onComplete = function(error) {
                  if (error) {
                    console.log('Updating shop failed');
                    console.error(error);
                  } else {
                    console.log('Updating shop succeeded');
                  }
                };


                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var shop_copy = $firebaseUtils.toJSON(shop);

                    var x = dataRef.child('shops').child(shopId).update(shop_copy,onComplete);
                    //Auth.$signOut();
                    deferred.resolve(x);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;
                
              },

              deleteShop: function (shopId) { 

                var onComplete = function(error) {
                  if (error) {
                    console.log('Deleting shop failed');
                    console.error(error);
                  } else {
                    console.log('Deleting shop succeeded');
                  }
                };

                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var x = dataRef.child('shops').child(shopId).remove(onComplete);
                    //Auth.$signOut();
                    deferred.resolve(x);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;

              },



              //CLASSIFIEDS

              allClassifieds: function () {
                return classifieds_list;
              },             


              createClassified: function (classified) {

                var onComplete = function(error) {
                  if (error) {
                    console.log('Adding classified failed');                    
                    console.error(error);
                  } else {
                    console.log('Adding classified succeeded');
                  }
                }; 

                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var classified_copy = $firebaseUtils.toJSON(classified);
                    var ref = dataRef.child('classifieds').push(classified_copy, onComplete);
                    //Auth.$signOut();  //Logout after saving data                                         
                    deferred.resolve(ref.key);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;                

              },

              getClassified: function (classifiedId) {

                  return $firebaseObject(dataRef.child('classifieds').child(classifiedId));                
              },

              updateClassified: function (classifiedId, classified) {

                var onComplete = function(error) {
                  if (error) {
                    console.log('Updating classified failed');
                    console.error(error);
                  } else {
                    console.log('Updating classified succeeded');
                  }
                };


                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var classified_copy = $firebaseUtils.toJSON(classified);

                    var x = dataRef.child('classifieds').child(classifiedId).update(classified_copy,onComplete);
                    //Auth.$signOut();
                    deferred.resolve(x);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;
                
              },

              deleteClassified: function (classifiedId) { 

                var onComplete = function(error) {
                  if (error) {
                    console.log('Deleting classified failed');
                    console.error(error);
                  } else {
                    console.log('Deleting classified succeeded');
                  }
                };

                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var x = dataRef.child('classifieds').child(classifiedId).remove(onComplete);
                    //Auth.$signOut();
                    deferred.resolve(x);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;

              },



              //USERS

              allUsers: function () {
                return users_list;
              },             


              createUser: function (user) {

                var onComplete = function(error) {
                  if (error) {
                    console.log('Adding user failed');                    
                    console.error(error);
                  } else {
                    console.log('Adding user succeeded');
                  }
                }; 

                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var user_copy = $firebaseUtils.toJSON(user);
                    var ref = dataRef.child('users').push(user_copy, onComplete);
                    //Auth.$signOut();  //Logout after saving data                                         
                    deferred.resolve(ref.key);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;                

              },

              getUser: function (userId) {

                  return $firebaseObject(dataRef.child('users').child(userId));                
              },

              updateUser: function (userId, user) {

                var onComplete = function(error) {
                  if (error) {
                    console.log('Updating user failed');
                    console.error(error);
                  } else {
                    console.log('Updating user succeeded');
                  }
                };


                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var user_copy = $firebaseUtils.toJSON(user);

                    var x = dataRef.child('users').child(userId).update(user_copy,onComplete);
                    //Auth.$signOut();
                    deferred.resolve(x);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;
                
              },

              deleteUser: function (userId) { 

                var onComplete = function(error) {
                  if (error) {
                    console.log('Deleting user failed');
                    console.error(error);
                  } else {
                    console.log('Deleting user succeeded');
                  }
                };

                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var x = dataRef.child('users').child(userId).remove(onComplete);
                    //Auth.$signOut();
                    deferred.resolve(x);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;

              },


              //Get Store Images

              getStoreImage: function(name,type){

                  var imagesRef;

                  if(type == 'shop'){
                      imagesRef = storageRef.ref('logos');
                  }else if(type == 'classified'){
                      imagesRef = storageRef.ref('classifieds');
                  }
                 

                  return imagesRef.child(name).getDownloadURL();

              }, 


              //Delete Store Image

              deleteStoreImage: function(name,type){

                  var imagesRef;

                  if(type == 'shop'){
                      imagesRef = storageRef.ref('logos');
                  }else if(type == 'classified'){
                      imagesRef = storageRef.ref('classifieds');
                  }
                 

                  return imagesRef.child(name).delete();

              },  



              //Get Images Metadata

              getImageMetaData: function(name,type){

                  var imagesRef;

                  if(type == 'shop'){
                      imagesRef = storageRef.ref('logos');
                  }else if(type == 'classified'){
                      imagesRef = storageRef.ref('classifieds');
                  }
                 

                  return imagesRef.child(name).getMetadata();

              },


              //Upload Store Images

              uploadStoreImage: function(type, file){

                  var that = this;

                  var imagesRef;

                  if(type == 'shop'){
                      imagesRef = storageRef.ref('logos');
                  }else if(type == 'classified'){
                      imagesRef = storageRef.ref('classifieds');
                  }else if(type == 'bigslider'){
                      imagesRef = storageRef.ref('landing_slider');
                  }else if(type == 'smallslider'){
                      imagesRef = storageRef.ref('top_slider');
                  }               


                  var Auth = this.auth();               

                  var deferred = $q.defer();
                                  
                  var promise = this.login(); //Check if am logged in before I upload file to firebase

                  promise.then(function(data) {

                    if(data != false){
                      
                        var uploadTask = imagesRef.child(file.name).put(file);

                        // Listen for state changes, errors, and completion of the upload.
                        uploadTask.on(firebase.storage.TaskEvent.STATE_CHANGED, function(snapshot) {
                            
                            // Get task progress, including the number of bytes uploaded and the total number of bytes to be uploaded
                            var progress = (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
                            //console.log('Upload is ' + progress + '% done');
                            that.setProgress(progress);
                            
                            switch (snapshot.state) {
                              case firebase.storage.TaskState.PAUSED: // or 'paused'
                                //console.log('Upload is paused');
                                break;
                              case firebase.storage.TaskState.RUNNING: // or 'running'
                                //console.log('Upload is running');
                                break;
                            }

                          }, function(error) {

                            switch (error.code) {
                              case 'storage/unauthorized':
                                // User doesn't have permission to access the object
                                console.log('User doesnt have permission to access the object');
                                console.error(error);
                                break;

                              case 'storage/canceled':
                                // User canceled the upload
                                console.log('User canceled the upload');
                                console.error(error);
                                break;

                              case 'storage/unknown':
                                // Unknown error occurred, inspect error.serverResponse
                                console.log('Unknown error occurred, inspect error.serverResponse');
                                console.error(error);
                                break;
                            }

                          }, function() {
                            // Upload completed successfully, now we can get the download URL
                            var downloadURL = uploadTask.snapshot.downloadURL;
                            deferred.resolve(downloadURL);
                          });                    

                    }//End of if(data != false){

                  },function(error) {                                  
                      console.error(error);
                      deferred.resolve(false);
                  });

                  return deferred.promise;

              },



              //DATABASE IMAGES LIST

              allImages: function (type) {
                
                if(type == 'shop'){
                  return shops_images_list;
                }else if(type == 'classified'){
                  return classifieds_images_list;
                }else if(type == 'bigslider'){
                  return big_slider_images_list;
                }else if(type == 'smallslider'){
                  return small_slider_images_list;
                }
                
              },             


              createImage: function (type, image) {

                var onComplete = function(error) {
                  if (error) {
                    console.log('Adding '+type+' image failed');                    
                    console.error(error);
                  } else {
                    console.log('Adding '+type+' image succeeded');
                  }
                }; 

                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var image_copy = $firebaseUtils.toJSON(image); 

                    var url = '';

                    if(type == 'shop'){
                      url = 'shopimages';
                    }else if(type == 'classified'){
                      url = 'classifiedsimages';
                    }else if(type == 'bigslider'){
                      url = 'bigsliderimages';
                    }else if(type == 'smallslider'){
                      url = 'smallsliderimages';
                    }                     

                    var ref = dataRef.child(url).push(image_copy, onComplete);

                    //Auth.$signOut();  //Logout after saving data                                         
                    deferred.resolve(ref.key);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;                

              },

              getImage: function (type, imageId) {

                  var url = '';

                  if(type == 'shop'){
                    url = 'shopimages';
                  }else if(type == 'classified'){
                    url = 'classifiedsimages';
                  }else if(type == 'bigslider'){
                      url = 'bigsliderimages';
                    }else if(type == 'smallslider'){
                      url = 'smallsliderimages';
                    }                  

                  return $firebaseObject(dataRef.child(url).child(imageId));

              },

              updateImage: function (type, imageId, image) {

                var onComplete = function(error) {
                  if (error) {
                    console.log('Updating image failed');
                    console.error(error);
                  } else {
                    console.log('Updating image succeeded');
                  }
                };


                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var image_copy = $firebaseUtils.toJSON(image);

                    var url = '';

                    if(type == 'shop'){
                      url = 'shopimages';
                    }else if(type == 'classified'){
                      url = 'classifiedsimages';
                    }else if(type == 'bigslider'){
                      url = 'bigsliderimages';
                    }else if(type == 'smallslider'){
                      url = 'smallsliderimages';
                    } 

                    var x = dataRef.child(url).child(imageId).update(image_copy,onComplete);

                    //Auth.$signOut();
                    deferred.resolve(x);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;
                
              },

              deleteImage: function (type, imageId) { 

                var onComplete = function(error) {
                  if (error) {
                    console.log('Deleting image failed');
                    console.error(error);
                  } else {
                    console.log('Deleting image succeeded');
                  }
                };

                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var url = '';

                    if(type == 'shop'){
                      url = 'shopimages';
                    }else if(type == 'classified'){
                      url = 'classifiedsimages';
                    }else if(type == 'bigslider'){
                      url = 'bigsliderimages';
                    }else if(type == 'smallslider'){
                      url = 'smallsliderimages';
                    }

                    var x = dataRef.child(url).child(imageId).remove(onComplete);
                    //Auth.$signOut();
                    deferred.resolve(x);

                  }

                },function(error) {                                  
                    console.error(error);
                    deferred.resolve(false);
                });

                return deferred.promise;

              },             

                        
              
              
          };
          
          

          connectedRef.on("value", function(snap) {

            if (snap.val() === true) {                 
                DataStore.setConnected(true);
            }else {                
                DataStore.setConnected(false);            
            }

          });

          return DataStore;
     

  }]);


});


