define(['./module'], function (services) {
   
      services.factory('modals', ["$state", "$uibModal", "$q", "$http", "settings", "properties", function($state, $uibModal, $q, $http, settings, properties){    	
          	          

            var root = {};         
            

            root.showNoticeModal = function(message, type) {
        
                var modalInstance = $uibModal.open({
                    animation: true,
                    templateUrl: 'partials/modals/notice.html',
                    controller: 'NoticeModalController',
                    size: 'md',
                    resolve: {

                      details: function () {
                        var ob = {};
                        ob.message = message;
                        ob.type = type;
                        return ob;
                      }              

                    }

                  });

                  modalInstance.result.then(function (result) {

                      //console.log(result);

                  }, function (dis) {

                      console.error(dis);

                  });

            };


            root.showConfirmModal = function(message) {

                var status;
                var deferred = $q.defer();
          
                var modalInstance = $uibModal.open({
                    animation: true,
                    templateUrl: 'partials/modals/confirm.html',
                    controller: 'ConfirmModalController',
                    size: 'md',
                    resolve: {

                      message: function () {                        
                        return message;
                      }              

                    }

                  });

                  modalInstance.result.then(function (result) {
                      
                      status = result;
                      deferred.resolve(status);

                  }, function (dis) {                     
                      status = dis;
                      deferred.resolve(status);
                  });

                  return deferred.promise;

            }; 


            

            //Show Survey Modal
            root.ShowSurveyModal = function(survey) {
        
                var modalInstance = $uibModal.open({
                    animation: true,
                    templateUrl: 'partials/modals/showsurvey.html',
                    controller: 'ShowSurveyModalController',
                    size: 'lg',
                    resolve: {
                      survey: function () {
                        return survey;
                      }
                    }

                  });

                  modalInstance.result.then(function (result) {

                      //console.log(result);

                  }, function (dis) {

                      console.error(dis);

                  });

             };


             //New Company Modal
             root.NewCompanyModal = function() {

                var that = this;
              
                  var modalInstance = $uibModal.open({
                      animation: true,
                      templateUrl: 'partials/modals/newcompany.html',
                      controller: 'NewCompanyModalController',
                      size: 'lg'
                    });

                    modalInstance.result.then(function (ob) {
                      
                      var result = ob.newcompany;                      
                      var company_id = settings.createCompany(result);

                    }, function (dis) {

                        console.error(dis);

                    });

             };


             //Show Company Modal
            root.ShowCompanyModal = function(company) {
        
                var modalInstance = $uibModal.open({
                    animation: true,
                    templateUrl: 'partials/modals/showcompany.html',
                    controller: 'ShowCompanyModalController',
                    size: 'md',
                    resolve: {
                      company: function () {
                        return company;
                      }
                    }

                  });

                  modalInstance.result.then(function (result) {

                      //console.log(result);

                  }, function (dis) {

                      console.error(dis);

                  });

             };


             //Edit Company Modal
             root.EditCompanyModal = function(company) {

                var that = this;
        
                var modalInstance = $uibModal.open({
                    animation: true,
                    templateUrl: 'partials/modals/editcompany.html',
                    controller: 'EditCompanyModalController',
                    size: 'lg',
                    resolve: {
                          companyid: function () {
                            return company.id;
                          },
                          editcompany:function(){
                                return company;
                          }
                    }

                });

                  modalInstance.result.then(function (ob) {                 

                        var result = ob.company;                     

                        var company_id = result.id;

                        //Save the application to firebase  
                        settings.updateCompany(company_id,result);


                  }, function (dis) {

                      console.error(dis);

                  });

             };
            

            root.isObject = function(ob){

                    var status = false;

                    if(ob !== null && typeof ob === 'object'){
                        status = true;
                    }

                    return status;  
            };

            root.isString = function(ob){
              
                  var status = false;

                  if(ob !== null && typeof ob === 'string'){
                      status = true;
                  }

                  return status;
            }; 
          

            return root;


      }]);

});
