define(['./module'], function (services) {
        
    services.factory('settings', ["$timeout", "$q", "$http", "$rootScope", "$state", "properties", function($timeout, $q, $http, $rootScope, $state, properties){
    	
      var host = 'http://www.izoneafrica.net/feedback-admin/';
                	
      var settings = {

          host: host,

          api_url: host+'api/index.php/survey',         

           layout: {
            pageSidebarClosed: false, // sidebar menu state
            pageContentWhite: true, // set page content layout
            pageBodySolid: false, // solid body color state
            pageAutoScrollOnLoad: 1000 // auto scroll to top on page load
          },

          assetsPath: 'assets',

          globalPath: 'assets/global',

          layoutPath: 'assets/layouts/layout4',

          login: function(user){

              var that = this; 

              var postData = JSON.stringify({
                  'username': user.username,
                  'password': user.password
              });

              return $http({
                method: 'POST',
                url: that.api_url + '/user/login/',
                headers: { 'Content-Type': 'application/json' },
                data: postData
              });

          },


          createCompany: function(details){

              var that = this; 

              var postData = JSON.stringify({
                  'company_name': details.company_name,
                  'email_address': details.email_address,
                  'industry': details.industry,
                  'take_survey': details.take_survey

              });

              return $http({
                method: 'POST',
                url: that.api_url + '/company/',
                headers: { 'Content-Type': 'application/json' },
                data: postData
              });

          },


          sendSurvey: function(){

              var that = this; 
              return $http.get(that.api_url + '/send/');

          },


          updateCompany: function(id,details){

              var that = this; 

              var postData = JSON.stringify({
                  'company_name': details.company_name,
                  'email_address': details.email_address,
                  'industry': details.industry,
                  'take_survey': details.take_survey
              });

              return $http({
                method: 'PUT',
                url: that.api_url + '/company/'+id,
                headers: { 'Content-Type': 'application/json' },
                data: postData
              });

          },

          deleteCompany: function(id){
                var that = this; 
                return $http.delete(that.api_url + '/company/'+id);
          },


          getCompanies: function () {
              var that = this;
              return $http.get(that.api_url + '/companies/');              
          },


          companies: function(){
              
              var that = this;

              var promise = that.getCompanies();

              promise.then(function(data){

                  var response = data.data;

                  if(response.success){                      
                      properties.setCompanies(response.companies);
                  }

              },function(error){
                  console.log(error);
              });

          }, 


          getSurveys: function () {
              var that = this;
              return $http.get(that.api_url + '/all/');              
          },


          deleteSurvey: function(id){
                var that = this; 
                return $http.delete(that.api_url + '/survey/'+id);
          },


          surveys: function(){
              
              var that = this;

              var promise = that.getSurveys();

              promise.then(function(data){

                  var response = data.data;

                  if(response.success){                      
                      properties.setSurveys(response.surveys);
                  }

              },function(error){
                  console.log(error);
              });

          },


          loadSurveys: function(){

              var status = false;
              var that = this;
              var deferred = $q.defer();

              var promise = that.getSurveys();

              promise.then(function(data) {
                  
                  var response = data.data;

                  if(response.success){
                    properties.setSurveys(response.surveys);
                    status = true;
                    deferred.resolve(status);
                  }else{
                    console.log('Server error: '+response.message);
                    deferred.resolve(status);
                  }              

              },function(error){                
                  console.log(error);
                  deferred.resolve(status);
              });

              return deferred.promise;
                  
          },


          loadCompanies: function(){

              var status = false;
              var that = this;
              var deferred = $q.defer();

              var promise = that.getCompanies();

              promise.then(function(data) {
                  
                  var response = data.data;

                  if(response.success){
                    properties.setCompanies(response.companies);
                    status = true;
                    deferred.resolve(status);
                  }else{
                    console.log('Server error: '+response.message);
                    deferred.resolve(status);
                  }              

              },function(error){                
                  console.log(error);
                  deferred.resolve(status);
              });

              return deferred.promise;
                  
          },          
          
      }; 

      $rootScope.settings = settings;   	

    	return settings;
      
    }]);

});
