//Configure all the files that the application needs
requirejs.config({
  baseUrl: "js",
  paths: {
    
    domReady: "plugins/domready/domReady",    
    jquery: "plugins/jquery-2.2.0.min",
    jmigrate: "plugins/jquery-migrate-1.4.1.min",
    bstrap: "plugins/bootstrap/js/bootstrap.min",
    btpls: "plugins/bootstrap/ui-bootstrap-tpls-1.3.3.min",
    uiutils: "plugins/ui-utils/ui-utils.min",
    ieshiv: "plugins/ui-utils/ui-utils-ieshiv.min",
    uiselect: "plugins/ui-select/select.min",
    bselect: "plugins/bootstrap-select/js/bootstrap-select.min",
    select2: "plugins/select2/js/select2.min",
    mselect: "plugins/jquery-multi-select/js/jquery.multi-select",
    'datatables.net': "plugins/datatables/media/js/jquery.dataTables",
    bdtables: "plugins/datatables/plugins/bootstrap/dataTables.bootstrap",
    'datatables.net-buttons': "plugins/datatables/extensions/Buttons/js/dataTables.buttons",
    dtbflash: "plugins/datatables/extensions/Buttons/js/buttons.flash",
    dtbzip: "plugins/datatables/extensions/Buttons/js/jszip.min",
    dtbpdf: "plugins/datatables/extensions/Buttons/js/pdfmake.min",
    dtbfonts: "plugins/datatables/extensions/Buttons/js/vfs_fonts",
    dtbhtml: "plugins/datatables/extensions/Buttons/js/buttons.html5",
    dtbprint: "plugins/datatables/extensions/Buttons/js/buttons.print",
    adtables: "plugins/angular-datatables/angular-datatables.min",
    adtbuttons: "plugins/angular-datatables/plugins/buttons/angular-datatables.buttons.min",
    dzone: "plugins/dropzone/dropzone",
    back: "plugins/backstretch/jquery.backstretch.min",
    hdropdown: "plugins/bootstrap-hover-dropdown/bootstrap-hover-dropdown.min",
    slimscroll: "plugins/jquery-slimscroll/jquery.slimscroll.min",
    blockui: "plugins/jquery.blockui.min",
    jcookie: "plugins/jquery.cokie.min",
    uniform: "plugins/uniform/jquery.uniform.min",
    uiRouter: "plugins/uirouter/angular-ui-router.min",    
    ocLazyLoad: "plugins/oclazy/ocLazyLoad.require.min",
    angular: "plugins/angularjs/angular",
    angularSanitize: "plugins/angularjs/angular-sanitize.min",
    angulartouch: "plugins/angularjs/angular-touch.min",
    main: "scripts/app",
    layout: "scripts/layout",
    sidebar: "scripts/quick-sidebar.min",
    demo: "scripts/demo.min",
    fdzone: "scripts/form-dropzone.min",
    moment: "plugins/moment.min",
    daterangepicker: "plugins/bootstrap-daterangepicker/daterangepicker",
    datepicker: "plugins/bootstrap-datepicker/js/bootstrap-datepicker.min"
    
  },

  shim: {

	angular: {            
        exports: 'angular'
    },

    jmigrate: {
        deps: ['jquery']
    },       
           
    uiRouter: {
        deps: ['angular']
    },

    moment: {
        exports: 'moment'
    },

    daterangepicker: {
        deps: ['jquery', 'moment'],
        exports: 'daterangepicker'
    },

    datepicker: {
        deps: ['jquery', 'moment'],
        exports: 'datepicker'
    },                   

    ocLazyLoad:{
        deps: ['angular']
    },        

    angularSanitize: {
        deps: ['angular']
    }, 

    angulartouch: {
        deps: ['angular']
    }, 

    bstrap: {
        deps: ['jquery', 'jmigrate']
    },

    btpls: {
        deps: ['bstrap','angular']
    },

    bselect: {
        deps: ['bstrap']
    },

    uiutils: {
        deps: ['bstrap', 'btpls']
    },

    ieshiv: {
        deps: ['bstrap', 'btpls']
    },

    uiselect: {
        deps: ['bstrap', 'angular', 'btpls', 'uiutils', 'ieshiv']
    },

    select2: {
        deps: ['jquery', 'jmigrate', 'bstrap']
    },

    mselect: {
        deps: ['jquery', 'jmigrate', 'bstrap', 'select2']
    },

    hdropdown: {
        deps: ['jquery', 'jmigrate']
    },

    slimscroll: {
        deps: ['jquery', 'jmigrate']
    },

    blockui: {
        deps: ['jquery', 'jmigrate']
    }, 

    jcookie: {
        deps: ['jquery', 'jmigrate']
    }, 

    uniform: {
        deps: ['jquery', 'jmigrate']
    },

    'datatables.net': {
        deps: ['jquery']
    },

    back: {
        deps: ['jquery']
    },

    bdtables: {
        deps: ['jquery', 'datatables.net']
    },

    adtables: {
        deps: ['jquery', 'datatables.net', 'angular']
    },

    'datatables.net-buttons': {
        deps: ['jquery', 'datatables.net', 'adtables']
    },

    adtbuttons: {
        deps: ['jquery', 'datatables.net', 'datatables.net-buttons', 'angular', 'adtables']
    },

    dtbflash: {
        deps: ['jquery', 'datatables.net', 'datatables.net-buttons', 'adtbuttons']
    },

    dtbzip: {
        deps: ['jquery', 'datatables.net', 'datatables.net-buttons']
    },

    dtbpdf: {
        deps: ['jquery', 'datatables.net', 'datatables.net-buttons']
    },

    dtbfonts: {
        deps: ['jquery', 'datatables.net', 'datatables.net-buttons']
    },

    dtbhtml: {
        deps: ['jquery', 'datatables.net', 'datatables.net-buttons', 'adtbuttons']
    },

    dtbprint: {
        deps: ['jquery', 'datatables.net', 'datatables.net-buttons', 'adtbuttons']
    },    

    dzone: {
        deps: ['jquery', 'jmigrate']
    },

    main: {
        deps: ['jquery', 'jmigrate', 'bstrap']
    },

    demo: {
        deps: ['jquery', 'jmigrate', 'main', 'bstrap']
    },

    layout: {
        deps: ['jquery', 'jmigrate', 'main', 'bstrap']
    },

    sidebar: {
        deps: ['jquery', 'jmigrate', 'main', 'bstrap']
    },

    fdzone: {
        deps: ['jquery', 'jmigrate', 'main', 'bstrap']
    },
       
    
  },

  // kick start application
  deps: ['./bootstrap']

});
