/** define all the application routes 
 **/
define(['./app'], function(app) {
    'use strict';
    return app.config(["$stateProvider", "$urlRouterProvider", "$ocLazyLoadProvider", "$sceDelegateProvider",  function($stateProvider, $urlRouterProvider, $ocLazyLoadProvider, $sceDelegateProvider) {
        
       
        $sceDelegateProvider.resourceUrlWhitelist([
            // Allow same origin resource loads.
            'self',
            // Allow loading from 192.168.1.* domain. 
            'http://192.168.1.*/**',

            // Allow loading from 192.168.0.* domain. 
            'http://192.168.0.*/**',

            // Allow loading from localhost domain. 
            'http://localhost/**'
        ]);        

        
        $urlRouterProvider.otherwise('/dashboard');
        
        $stateProvider.state('dashboard', {
            url: "/dashboard",
            templateUrl: "partials/dashboard.html",            
            data: {pageTitle: 'Dashboard', pageSubTitle: 'a summary of the surveys and companies'},
            controller: "DashboardController"
        })
        

        
        // Login Route
        /*.state('login', {
            url: "/login",
            templateUrl: "partials/login.html",            
            data: {pageTitle: 'Login', pageSubTitle: 'restricted area'},
            controller: "LoginController",            
            resolve: {                
                deps: ['$ocLazyLoad', function($ocLazyLoad) {
                    return $ocLazyLoad.load({                        
                        insertBefore: '#ng_load_plugins_before', 
                        files: [                            
                            'js/plugins/select2/css/select2.min.css',
                            'js/plugins/select2/css/select2-bootstrap.min.css',
                            'assets/pages/css/login-4.min.css',
                            'js/plugins/select2/js/select2.full.min.js',                            
                            'assets/pages/scripts/login.js'
                        ] 
                    });
                }]
            }
        }) */


        .state('surveys', {
            url: "/surveys",
            templateUrl: "partials/surveys.html",            
            data: {pageTitle: 'Surveys', pageSubTitle: 'Survey listing within the mall'},
            controller: "SurveysController"
        })


        .state('companies', {
            url: "/companies",
            templateUrl: "partials/companies.html",            
            data: {pageTitle: 'Companies', pageSubTitle: 'Companies listing within the mall'},
            controller: "CompaniesController"
        })
                

        // User Profile
        .state("profile", {
            url: "/profile",
            templateUrl: "partials/profile/main.html",
            data: {pageTitle: 'User Profile', pageSubTitle: 'user details'},
            controller: "UserProfileController",            
            resolve: {
                deps: ['$ocLazyLoad', function($ocLazyLoad) {
                    return $ocLazyLoad.load({                          
                        insertBefore: '#ng_load_plugins_before', 
                        files: [
                            'js/plugins/bootstrap-fileinput/bootstrap-fileinput.css',
                            'assets/pages/css/profile.css',                            
                            'js/plugins/jquery.sparkline.min.js',
                            'js/plugins/bootstrap-fileinput/bootstrap-fileinput.js',
                            'assets/pages/scripts/profile.min.js'
                            
                        ]                    
                    });
                }],                
                currentAuth: ["datastore", function(datastore) {
                  return datastore.auth().$requireSignIn();
                }]
            }
        })


        // User Profile Dashboard
        .state("profile.dashboard", {
            url: "/dashboard",
            templateUrl: "partials/profile/dashboard.html",
            data: {pageTitle: 'User Profile'}
        })


        // User Profile Account
        .state("profile.account", {
            url: "/account",
            templateUrl: "partials/profile/account.html",
            data: {pageTitle: 'User Account'}
        });
              


    }])
});